/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package housetemplatemethodpattern;

public abstract class HouseTemplate {
 
    //template method, final so subclasses can't override
    public final void buildHouse(){
        buildFoundation();
        buildPillars();
        buildWalls();
        buildWindows();
        System.out.println("House is built.");
    }
 
    //default implementation
    private void buildWindows() {
        System.out.println("Building Glass Windows");
    }
 
    //methods to be implemented by subclasses
    public abstract void buildWalls();
    public abstract void buildPillars();
 
    private void buildFoundation() {
        System.out.println("Building foundation with cement,iron rods and sand");
    }
}